#include "ctrl.h"

#include <avr/io.h>
#include "../sie/Sie.h"
#include "xdc.h"


void ctrlInit()
{
	//VGA Enable as Output
	DDRG |= (1 << PG5);
	PORTG |= (1 << PG5);

	//LCD ON as output
	DDRE |= (1 << PE3);
	PORTE |= (1 << PE3);

	xdcInit();

	xdcEnable(1);
	xdcSetReferenceValues(700, 310, 40);
}

void ctrlPmCallback(siePacket packet)
{
	if(packet.command == 0x23)
	{
		ctrlLcdEnable(packet.data[0]);
	}
	else if(packet.command == 0x24)
	{
		ctrlVgaEnable(packet.data[0]);
	}

/*
	else if(packet.command == 0x22)
	{
		ctrlSetBacklightIntensity(packet.data[0], );
	}
*/

}

void ctrlSetBacklightIntensity(unsigned int intensity, unsigned char hystersis)
{	
	xdcSetReferenceValues(700, intensity, hystersis);
}

void ctrlVgaEnable(unsigned char enable)
{
	if(enable)
	{
		PORTG |= (1 << PG5);
	}
	else
	{
		PORTG &= ~(1 << PG5);		
	}
}

void ctrlLcdEnable(unsigned char enable)
{
	xdcEnable(enable);
	
	if(enable)
	{
		PORTE |= (1 << PE3);
	}
	else
	{
		PORTE &= ~(1 << PE3);
	}	
}
