#include <avr/interrupt.h>

#include "xdc.h"
#include "i2csw.h"

void xdcInit()
{
	i2cswInit();
	//si2c_init();
}

void xdcEnable(unsigned char enable)
{
	xdcRegisterWrite(6,enable);
}

unsigned char xdcRegisterWrite(unsigned char reg, unsigned char data)
{

//	cli();
	unsigned char ndata[1];
	ndata[0] = data;
	i2cswSend(0x30, reg, 1, ndata);
//	sei();
}
unsigned char xdcIntRegisterWrite(unsigned char reg, unsigned int data)
{
//	cli();
	unsigned char ndata[2];
	ndata[0] = data & 0x00FF;
	ndata[1] = data >> 8;
	i2cswSend(0x30, reg, 2, ndata);	
//	sei();
}

void xdcSetReferenceValues(unsigned int voltage, unsigned int current, unsigned char current_hysteresis)
{	
	xdcIntRegisterWrite(0, voltage);
	xdcIntRegisterWrite(2, current);
	xdcRegisterWrite(5, current_hysteresis);
}

