#include "LedMix.h"
#include "Iox.h"
#include "../blib/default.h"


unsigned char ledMixRGB[8][3];
unsigned char ledCycleCount = 0;
unsigned char ledMixButtonIndexes[] = {0, 3, 7, 4};
unsigned char ledMixWheelIndexes[] = {6, 5, 2, 1};


void ledMixInterruptRoutine()
{
	unsigned char i = 0, tmp[4];

	ledCycleCount++;
	ledCycleCount %= 5;

	for(i = 0; i < 4; i++)
	{
		tmp[i] = 0;
		if(ledCycleCount >= ledMixRGB[2*i][0])
		{
			tmp[i] |= B8(00000001);
		}
		if(ledCycleCount >= ledMixRGB[2*i][1])
		{
			tmp[i] |= B8(00000010);
		}
		if(ledCycleCount >= ledMixRGB[2*i][2])
		{
			tmp[i] |= B8(00000100);
		}
		if(ledCycleCount >= ledMixRGB[2*i+1][0])
		{
			tmp[i] |= B8(00100000);
		}
		if(ledCycleCount >= ledMixRGB[2*i+1][1])
		{
			tmp[i] |= B8(01000000);
		}
		if(ledCycleCount >= ledMixRGB[2*i+1][2])
		{
			tmp[i] |= B8(10000000);
		}	
	}
	
	i2cStart(IOX_ADDRESS_A);
	i2cWrite(0x14);
	i2cWrite(tmp[0]);
	i2cWrite(tmp[1]);
	i2cStop();

	i2cStart(IOX_ADDRESS_B);
	i2cWrite(0x14);
	i2cWrite(tmp[2]);
	i2cWrite(tmp[3]);
	i2cStop();	
}


void ledMixInit(ledMixInterruptRoutine)
{
	i2cInit();

	IoxPORTWrite(0, 0xFF);
	IoxPORTWrite(1, 0xFF);
	IoxPORTWrite(2, 0xFF);
	IoxPORTWrite(3, 0xFF);

	IoxDDRWrite(0, 0xFF);
	IoxDDRWrite(1, 0xFF);
	IoxDDRWrite(2, 0xFF);
	IoxDDRWrite(3, 0xFF);	
}

void ledMix(unsigned char led, unsigned char red, unsigned char green, unsigned char blue)
{
	ledMixRGB[led][0] = red;
	ledMixRGB[led][1] = green;
	ledMixRGB[led][2] = blue;
}

inline void ledMixWheel(unsigned char index, unsigned char red, unsigned char green, unsigned char blue)
{
	ledMix(ledMixWheelIndexes[index%4], red, green, blue);
}

inline void ledMixButton(unsigned char index, unsigned char red, unsigned char green, unsigned char blue)
{
	ledMix(ledMixButtonIndexes[index], red, green, blue);	
}
