#include <avr/io.h>
#include <avr/interrupt.h>
#include "blib/default.h"
#include "blib/timer.h"
#include "blib/rs232.h"
#include "ctrl/ctrl.h"
#include "ctrl/pm.h"

#include "ui/Ui.h"
#include "ui/CapInterface.h"

int main()
{
	int i = 0;

	ctrlInit();
	ctrlLcdEnable(1);
	ctrlVgaEnable(0);
	uiRegisterPmPacketHandler(ctrlPmCallback);
	uiInit();
	
	pmInit();

	sei();

	capInterfaceWheelClear();
	capInterfaceButtonsClear();

	uiSieUnlock();

	for(i = 0; !uiMasterReady; i++)
	{
		uiPacketSubmit(0x11, 0, 0);
		capInterfaceBlinkInitialSequence(i);
		mSleep(400);
		pmWakeupCall(); //Be sure that all peripherials stay online during boot sequence
	}

	capInterfaceWheelClear();	

	while(true)
	{

	}
}
